"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPromise = exports.isFailureLike = exports.isSuccessLike = exports.isHaveStatus = exports.isErrType = exports.isErr = void 0;
const isErr = (input) => {
    return typeof input === 'object' && input !== null && 'type' in input;
};
exports.isErr = isErr;
const isErrType = (type, input) => {
    if ((0, exports.isErr)(input)) {
        return input.type === type;
    }
    return false;
};
exports.isErrType = isErrType;
const isHaveStatus = (input) => {
    if (!(typeof input === 'object' && input !== null)) {
        return false;
    }
    return 'status' in input;
};
exports.isHaveStatus = isHaveStatus;
const isSuccessLike = (input) => {
    if (!(0, exports.isHaveStatus)(input)) {
        return false;
    }
    return input.status === 'success';
};
exports.isSuccessLike = isSuccessLike;
const isFailureLike = (input) => {
    if (!(0, exports.isHaveStatus)(input)) {
        return false;
    }
    return input.status === 'error';
};
exports.isFailureLike = isFailureLike;
const isPromise = (data) => {
    return data !== null && typeof data === 'object' && 'then' in data;
};
exports.isPromise = isPromise;
//# sourceMappingURL=checks.js.map