export declare const ErrLevel: {
    readonly Emerg: 0;
    readonly Alert: 1;
    readonly Crit: 2;
    readonly Error: 3;
    readonly Warning: 4;
    readonly Notice: 5;
    readonly Info: 6;
    readonly Debug: 7;
};
export interface Err {
    type: string;
    message?: string;
    level?: number;
    retry?: boolean;
    notify?: boolean;
    fatal?: boolean;
}
export declare type ErrUtil<T = unknown, A = {}> = T extends string ? {
    [k in keyof ({
        type: T;
    } & A)]: ({
        type: T;
    } & A)[k];
} & Err : T extends {
    type: string;
} ? {
    [k in keyof (T & A)]: (T & A)[k];
} & Err : A extends {
    type: string;
} ? {
    [k in keyof (T & A)]: (T & A)[k];
} & Err : Err;
export declare type Errs<Errors> = Errors[keyof Errors] extends Err ? Errors[keyof Errors] : {
    [Type in Exclude<keyof Errors, 'name'>]: ErrUtil<Type extends string ? Errors extends {
        name: string;
    } ? `${Errors['name']}${Type}` : Type : never, Errors[Type] extends string ? {} : Exclude<Errors[Type], 'type'>>;
};
//# sourceMappingURL=err.d.ts.map