import { Result, Failure, Success, PartialResult, PartialFailure } from './result';
import { Err } from './err';
export declare class FailureException<Fail> extends Error implements PartialFailure<Fail> {
    status: 'error';
    error: Fail;
    code?: number;
    order?: number;
    constructor(t: string, e: Fail, o?: number, m?: string, c?: number);
}
export declare const complete: <Data, Fail>(partial: PartialResult<Data, Fail>) => Result<Data, Fail>;
declare type OkMessage = {
    code?: number;
    order?: number;
    skip?: boolean;
};
export declare type OkFn = <Data = never>(data: Data, params?: OkMessage) => Success<Data>;
export declare const ok: OkFn;
declare type FailMessage = {
    code?: number;
    message?: string;
    order?: number;
    skip?: boolean;
};
export declare const err: <Fail = never>(failure: Fail, { message, code, order, skip }?: FailMessage) => Failure<Fail>;
declare type ErrorMessage<Error> = FailMessage & Omit<Error, 'type' | 'message'>;
export declare type FailFn = <Fail extends Err | undefined = never>(type: Fail extends Err ? Fail['type'] : undefined, params?: ErrorMessage<Fail>) => Failure<Fail>;
export declare const fail: FailFn;
export declare type ThrowFailFn = <Fail extends Err | undefined = never>(type: Fail extends Err ? Fail['type'] : undefined, params?: ErrorMessage<Fail>) => never;
export declare const throwFail: ThrowFailFn;
export declare const compare: <Data1, Error1, Data2, Error2>(r1: Result<Data1, Error1>, r2: Result<Data2, Error2>) => Result<Data1 | Data2, Error1 | Error2>;
export declare const toResult: <Data, Error_1>(input: unknown) => Result<Data, Error_1>;
export declare function nope(p: never): never;
export {};
//# sourceMappingURL=utils.d.ts.map